#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <assert.h>

typedef struct Node {
    int item;
    struct Node* next;
} Node;

typedef struct Queue {
    Node* head;
    Node* tail;

    void (*push) (struct Queue*, int);
    int (*pop) (struct Queue*);
    int (*peek) (struct Queue*);
    void (*display) (struct Queue*);
    int size;
} Queue;


Queue queue;

void push (Queue* queue, int item);
int pop (Queue* queue);
int peek (Queue* queue);
void display (Queue* queue);
Queue createQueue ();

void* funth( void *x ) {
    queue.push(&queue,x);
    return NULL;
}

int main () {
    queue = createQueue();
    queue.display(&queue);

    pthread_t th1;
    pthread_t th2;

    int a = 1;
    int b = 42;

    printf("povodne a je: %d\n", a);
    printf("povodne b je: %d\n", b);


    pthread_create(&th1, NULL, funth, (void *) 1);
    pthread_create(&th2, NULL, funth, (void *) 42);

    pthread_join( th1, NULL );
    pthread_join( th2, NULL );

    queue.display(&queue);

    a = queue.pop(&queue);
    b = queue.pop(&queue);

    printf("popped a je: %d\n", a);
    printf("popped b je: %d\n", b);

    assert(a == 1);
    assert(b == 42);

    return 0;
}

void push (Queue* queue, int item) {
    Node* n = (Node*) malloc (sizeof(Node));
    n->item = item;
    n->next = NULL;

    if (queue->head == NULL) { // no head
        queue->head = n;
    } else{
        queue->tail->next = n;
    }
    queue->tail = n;
    queue->size++;
}

int pop (Queue* queue) {
    Node* head = queue->head;
    int item = head->item;
    queue->head = head->next;
    queue->size--;
    free(head);
    return item;
}

int peek (Queue* queue) {
    Node* head = queue->head;
    return head->item;
}

void display (Queue* queue) {
    printf("\nDisplay: ");
      if (queue->size == 0)
        printf("No item in queue.\n");
    else { // has item(s)
        Node* head = queue->head;
        int i, size = queue->size;
        printf("%d item(s):\n", queue->size);
        for (i = 0; i < size; i++) {
            if (i > 0)
                printf(", ");
            printf("%d", head->item);
            head = head->next;
        }
    }
    printf("\n\n");
}

Queue createQueue () {
    Queue queue;
    queue.size = 0;
    queue.head = NULL;
    queue.tail = NULL;
    queue.push = &push;
    queue.pop = &pop;
    queue.peek = &peek;
    queue.display = &display;
    return queue;
}

